/*
 * AssistantView.java
 *
 * Created on November 26, 2001, 12:25 AM
 */

package com.sams.jxta.pda;
import net.jxta.peergroup.*;
import com.sams.jxta.xcal.*;
import com.sams.jxta.vcard.*;
import javax.swing.DefaultListModel;
import com.sams.jxta.swing.PeerGroupRenderer;
/**
 *
 * @author  Administrator
 */
public class AssistantView extends javax.swing.JFrame {
    protected JPDA jPDA;
    
    /** Creates new form AssistantView */
    public AssistantView(JPDA jPDA) {
        this.jPDA = jPDA;
        initComponents();
        setTitle(getTitle()+" Peer:"+jPDA.getNetPeerGroup().getPeerName());
        
        calendarList.setModel(new  DefaultListModel());
        toDoList.setModel(new DefaultListModel());
        
        addressList.setModel(new DefaultListModel());
        memberGroupList.setModel(new DefaultListModel());
        knownGroupList.setModel(new DefaultListModel());
        
        jPDA.addCalendarModel((DefaultListModel)calendarList.getModel());
        jPDA.addToDoModel((DefaultListModel)toDoList.getModel());
        jPDA.addAddressModel((DefaultListModel)addressList.getModel());
        
        ((DefaultListModel)memberGroupList.getModel()).addElement(jPDA.getRootJPDA());
        memberGroupList.setCellRenderer(new PeerGroupRenderer());
        knownGroupList.setCellRenderer(new PeerGroupRenderer());
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jPopupMenu1 = new javax.swing.JPopupMenu();
        jSplitPane2 = new javax.swing.JSplitPane();
        jSplitPane1 = new javax.swing.JSplitPane();
        addressGroupListScrollPane = new javax.swing.JScrollPane();
        memberGroupList = new javax.swing.JList();
        pdaTabbedPane1 = new javax.swing.JTabbedPane();
        addressPanel = new javax.swing.JPanel();
        addressScrollPane = new javax.swing.JScrollPane();
        addressList = new javax.swing.JList();
        addressButtonPanel = new javax.swing.JPanel();
        newAddressButton = new javax.swing.JButton();
        viewEditAddressButton = new javax.swing.JButton();
        calendarPanel = new javax.swing.JPanel();
        calendarListScrollPane = new javax.swing.JScrollPane();
        calendarList = new javax.swing.JList();
        calendarButtonPanel = new javax.swing.JPanel();
        newEventButton = new javax.swing.JButton();
        viewEditCalendarButton = new javax.swing.JButton();
        toDoPanel = new javax.swing.JPanel();
        toDoScrollPane = new javax.swing.JScrollPane();
        toDoList = new javax.swing.JList();
        addressButtonPanel1 = new javax.swing.JPanel();
        newAddressButton1 = new javax.swing.JButton();
        viewEditAddressButton1 = new javax.swing.JButton();
        groupPanel = new javax.swing.JPanel();
        newGroupPanel = new javax.swing.JPanel();
        jPanel1 = new javax.swing.JPanel();
        jPanel2 = new javax.swing.JPanel();
        jPanel3 = new javax.swing.JPanel();
        jPanel7 = new javax.swing.JPanel();
        newGroupNameTextField = new javax.swing.JTextField();
        jPanel8 = new javax.swing.JPanel();
        newGroupDescTextField = new javax.swing.JTextField();
        jPanel6 = new javax.swing.JPanel();
        newGroupButton = new javax.swing.JButton();
        joinGroupPanel = new javax.swing.JPanel();
        joinGroupButtonPanel = new javax.swing.JPanel();
        jPanel4 = new javax.swing.JPanel();
        groupListScrollPane = new javax.swing.JScrollPane();
        knownGroupList = new javax.swing.JList();
        jPanel5 = new javax.swing.JPanel();
        joinGroupButton = new javax.swing.JButton();
        jMenuBar1 = new javax.swing.JMenuBar();
        fileMenu = new javax.swing.JMenu();
        debugCheckBoxMenuItem1 = new javax.swing.JCheckBoxMenuItem();
        syncMenuItem = new javax.swing.JMenuItem();
        exitMenu = new javax.swing.JMenuItem();
        editMenu = new javax.swing.JMenu();
        deleteMenuItem2 = new javax.swing.JMenuItem();
        helpMenu = new javax.swing.JMenu();
        jMenuItem1 = new javax.swing.JMenuItem();

        setTitle("JXTA Personal Digital Assistant");
        setDefaultCloseOperation(javax.swing.JFrame.EXIT_ON_CLOSE);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });

        addressGroupListScrollPane.setViewportBorder(new javax.swing.border.TitledBorder("Groups"));
        addressGroupListScrollPane.setPreferredSize(new java.awt.Dimension(150, 131));
        addressGroupListScrollPane.setViewportView(memberGroupList);

        jSplitPane1.setLeftComponent(addressGroupListScrollPane);

        addressPanel.setLayout(new java.awt.BorderLayout());

        addressScrollPane.setViewportBorder(new javax.swing.border.TitledBorder("Address Book"));
        addressList.setVisibleRowCount(15);
        addressList.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                addressListValueChanged(evt);
            }
        });

        addressScrollPane.setViewportView(addressList);

        addressPanel.add(addressScrollPane, java.awt.BorderLayout.CENTER);

        newAddressButton.setText("New Address");
        newAddressButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                newAddressButtonActionPerformed(evt);
            }
        });

        addressButtonPanel.add(newAddressButton);

        viewEditAddressButton.setText("View/Edit");
        viewEditAddressButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                viewEditAddressButtonActionPerformed(evt);
            }
        });

        addressButtonPanel.add(viewEditAddressButton);

        addressPanel.add(addressButtonPanel, java.awt.BorderLayout.SOUTH);

        pdaTabbedPane1.addTab("Address Book", addressPanel);

        calendarPanel.setLayout(new java.awt.BorderLayout());

        calendarListScrollPane.setBorder(new javax.swing.border.TitledBorder("Events"));
        calendarListScrollPane.setViewportView(calendarList);

        calendarPanel.add(calendarListScrollPane, java.awt.BorderLayout.CENTER);

        newEventButton.setText("New Event");
        newEventButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                newEventButtonActionPerformed(evt);
            }
        });

        calendarButtonPanel.add(newEventButton);

        viewEditCalendarButton.setText("View/Edit");
        viewEditCalendarButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                viewEditCalendarButtonActionPerformed(evt);
            }
        });

        calendarButtonPanel.add(viewEditCalendarButton);

        calendarPanel.add(calendarButtonPanel, java.awt.BorderLayout.SOUTH);

        pdaTabbedPane1.addTab("Calendar", calendarPanel);

        toDoPanel.setLayout(new java.awt.BorderLayout());

        toDoScrollPane.setViewportBorder(new javax.swing.border.TitledBorder("To Do List"));
        toDoScrollPane.setViewportView(toDoList);

        toDoPanel.add(toDoScrollPane, java.awt.BorderLayout.CENTER);

        newAddressButton1.setText("New To Do");
        newAddressButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                newAddressButton1ActionPerformed(evt);
            }
        });

        addressButtonPanel1.add(newAddressButton1);

        viewEditAddressButton1.setText("View/Edit");
        addressButtonPanel1.add(viewEditAddressButton1);

        toDoPanel.add(addressButtonPanel1, java.awt.BorderLayout.SOUTH);

        pdaTabbedPane1.addTab("To Do List", toDoPanel);

        newGroupPanel.setLayout(new javax.swing.BoxLayout(newGroupPanel, javax.swing.BoxLayout.Y_AXIS));

        jPanel1.setLayout(new javax.swing.BoxLayout(jPanel1, javax.swing.BoxLayout.X_AXIS));

        jPanel1.setBorder(new javax.swing.border.TitledBorder("Add New Group"));
        jPanel2.setLayout(new javax.swing.BoxLayout(jPanel2, javax.swing.BoxLayout.Y_AXIS));

        jPanel7.setBorder(new javax.swing.border.TitledBorder("Group Name"));
        newGroupNameTextField.setColumns(15);
        jPanel7.add(newGroupNameTextField);

        jPanel3.add(jPanel7);

        jPanel8.setBorder(new javax.swing.border.TitledBorder("Group Description"));
        newGroupDescTextField.setColumns(15);
        newGroupDescTextField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                newGroupDescTextFieldActionPerformed(evt);
            }
        });

        jPanel8.add(newGroupDescTextField);

        jPanel3.add(jPanel8);

        jPanel2.add(jPanel3);

        newGroupButton.setText("New Group");
        newGroupButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                newGroupButtonActionPerformed(evt);
            }
        });

        jPanel6.add(newGroupButton);

        jPanel2.add(jPanel6);

        jPanel1.add(jPanel2);

        newGroupPanel.add(jPanel1);

        joinGroupPanel.setLayout(new java.awt.BorderLayout());

        joinGroupButtonPanel.setLayout(new javax.swing.BoxLayout(joinGroupButtonPanel, javax.swing.BoxLayout.Y_AXIS));

        joinGroupButtonPanel.setBorder(new javax.swing.border.TitledBorder("Join Group"));
        knownGroupList.setDoubleBuffered(true);
        knownGroupList.setFixedCellWidth(350);
        groupListScrollPane.setViewportView(knownGroupList);

        jPanel4.add(groupListScrollPane);

        joinGroupButtonPanel.add(jPanel4);

        joinGroupButton.setText("Join Group");
        joinGroupButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                joinGroupButtonActionPerformed(evt);
            }
        });

        jPanel5.add(joinGroupButton);

        joinGroupButtonPanel.add(jPanel5);

        joinGroupPanel.add(joinGroupButtonPanel, java.awt.BorderLayout.SOUTH);

        newGroupPanel.add(joinGroupPanel);

        groupPanel.add(newGroupPanel);

        pdaTabbedPane1.addTab("Groups", groupPanel);

        jSplitPane1.setRightComponent(pdaTabbedPane1);

        getContentPane().add(jSplitPane1, java.awt.BorderLayout.CENTER);

        fileMenu.setText("File");
        debugCheckBoxMenuItem1.setText("Debug Mode");
        fileMenu.add(debugCheckBoxMenuItem1);
        syncMenuItem.setText("Synchronize");
        syncMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                syncMenuItemActionPerformed(evt);
            }
        });

        fileMenu.add(syncMenuItem);
        exitMenu.setText("Exit");
        fileMenu.add(exitMenu);
        jMenuBar1.add(fileMenu);
        editMenu.setText("Edit");
        deleteMenuItem2.setText("Delete");
        editMenu.add(deleteMenuItem2);
        jMenuBar1.add(editMenu);
        helpMenu.setText("Help");
        helpMenu.setHorizontalTextPosition(javax.swing.SwingConstants.RIGHT);
        jMenuItem1.setText("About");
        helpMenu.add(jMenuItem1);
        jMenuBar1.add(helpMenu);
        setJMenuBar(jMenuBar1);

        pack();
    }//GEN-END:initComponents
    
    private void newGroupDescTextFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_newGroupDescTextFieldActionPerformed
        // Add your handling code here:
    }//GEN-LAST:event_newGroupDescTextFieldActionPerformed
    
    private void newAddressButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_newAddressButton1ActionPerformed
        VToDo vToDo = new VToDo();
        EditToDo editToDo = new EditToDo(this,true,vToDo);
        editToDo.show(true);
        if (editToDo.getReturnStatus()==EditEvent.RET_OK){
            PeerGroup peerGroup = (PeerGroup)memberGroupList.getSelectedValue();
            System.out.println("==== "+peerGroup.getPeerGroupName()+" ===");
            jPDA.addToDo(peerGroup,vToDo);
            memberGroupList.setSelectedIndex(-1);
        }
    }//GEN-LAST:event_newAddressButton1ActionPerformed
    
    private void syncMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_syncMenuItemActionPerformed
        // Causes this peer to request information about other peer address books
        jPDA.synchronize();
    }//GEN-LAST:event_syncMenuItemActionPerformed
    
    private void addressListValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_addressListValueChanged
        // Add your handling code here:
    }//GEN-LAST:event_addressListValueChanged
    
    private void joinGroupButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_joinGroupButtonActionPerformed
        PeerGroup peerGroup = (PeerGroup)knownGroupList.getSelectedValue();
        Object credential = jPDA.joinGroup(peerGroup);
        if(credential != null){
            DefaultListModel model = (DefaultListModel)memberGroupList.getModel();
            model.addElement(peerGroup);
            jPDA.addNewGroup(peerGroup);
            DefaultListModel knownModel = (DefaultListModel)knownGroupList.getModel();
            knownModel.remove(knownGroupList.getSelectedIndex());
            knownGroupList.setSelectedIndex(-1);
             memberGroupList.setSelectedIndex(-1);
            
        }else{
            //Runtime.getRuntime()..beep();
        }
       

    }//GEN-LAST:event_joinGroupButtonActionPerformed
    
    private void newGroupButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_newGroupButtonActionPerformed
        
        PeerGroup newJPDA = jPDA.addGroup(newGroupNameTextField.getText(),newGroupDescTextField.getText());
        DefaultListModel model = (DefaultListModel)knownGroupList.getModel();
        model.addElement(newJPDA);
        newGroupNameTextField.setText("");
        newGroupDescTextField.setText("");
        //jPDA.joinGroup(newJPDA);
    }//GEN-LAST:event_newGroupButtonActionPerformed
    
    private void viewEditCalendarButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_viewEditCalendarButtonActionPerformed
        XCal xCal = new XCal();
        EditEvent event = new EditEvent(this,true,xCal);
        event.show(true);
        if (event.getReturnStatus()==EditEvent.RET_OK){
            PeerGroup peerGroup = (PeerGroup)memberGroupList.getSelectedValue();
            jPDA.updateEvent( peerGroup, xCal);
        }
                memberGroupList.setSelectedIndex(-1);

    }//GEN-LAST:event_viewEditCalendarButtonActionPerformed
    
    private void newEventButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_newEventButtonActionPerformed
        XCal xCal = new XCal();
        EditEvent EditEvent = new EditEvent(this,true,xCal);
        EditEvent.show(true);
        if (EditEvent.getReturnStatus()==EditEvent.RET_OK){
            PeerGroup peerGroup = (PeerGroup)memberGroupList.getSelectedValue();
            jPDA.addEvent(peerGroup, xCal);
        }
                memberGroupList.setSelectedIndex(-1);

    }//GEN-LAST:event_newEventButtonActionPerformed
    
    private void newAddressButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_newAddressButtonActionPerformed
        VCard vCard = new VCard();
        EditAddress address = new EditAddress(this,true,vCard);
        address.show(true);
        
        if (address.getReturnStatus()==address.RET_OK){
            PeerGroup peerGroup = (PeerGroup)memberGroupList.getSelectedValue();
            System.out.println("==== "+peerGroup.getPeerGroupName()+" ===");
            jPDA.addEntry(peerGroup,vCard);
        }
        memberGroupList.setSelectedIndex(-1);
    }//GEN-LAST:event_newAddressButtonActionPerformed
    
    private void viewEditAddressButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_viewEditAddressButtonActionPerformed
        VCard vCard = new VCard();
        EditAddress address = new EditAddress(this,true,vCard);
        address.show(true);
        if (address.getReturnStatus()==address.RET_OK){
            PeerGroup peerGroup = (PeerGroup)memberGroupList.getSelectedValue();
            jPDA.addEntry(peerGroup,vCard);
        }
        memberGroupList.setSelectedIndex(-1);

    }//GEN-LAST:event_viewEditAddressButtonActionPerformed
    
    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        System.exit(0);
    }//GEN-LAST:event_exitForm
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        new AssistantView(null).show();
    }
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel addressButtonPanel1;
    private javax.swing.JPanel toDoPanel;
    private javax.swing.JButton viewEditCalendarButton;
    private javax.swing.JList memberGroupList;
    private javax.swing.JScrollPane addressScrollPane;
    private javax.swing.JScrollPane toDoScrollPane;
    private javax.swing.JScrollPane groupListScrollPane;
    private javax.swing.JButton viewEditAddressButton;
    private javax.swing.JPanel addressPanel;
    private javax.swing.JTextField newGroupDescTextField;
    private javax.swing.JScrollPane addressGroupListScrollPane;
    private javax.swing.JButton newAddressButton;
    private javax.swing.JMenu helpMenu;
    private javax.swing.JButton viewEditAddressButton1;
    private javax.swing.JCheckBoxMenuItem debugCheckBoxMenuItem1;
    private javax.swing.JButton newEventButton;
    private javax.swing.JPanel calendarButtonPanel;
    private javax.swing.JList calendarList;
    private javax.swing.JList toDoList;
    private javax.swing.JPanel addressButtonPanel;
    private javax.swing.JPanel joinGroupButtonPanel;
    private javax.swing.JButton newGroupButton;
    private javax.swing.JMenuBar jMenuBar1;
    private javax.swing.JPanel groupPanel;
    private javax.swing.JPopupMenu jPopupMenu1;
    private javax.swing.JPanel joinGroupPanel;
    private javax.swing.JMenuItem jMenuItem1;
    private javax.swing.JPanel jPanel8;
    private javax.swing.JPanel jPanel7;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JMenuItem exitMenu;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JList addressList;
    private javax.swing.JPanel newGroupPanel;
    private javax.swing.JScrollPane calendarListScrollPane;
    private javax.swing.JMenuItem syncMenuItem;
    private javax.swing.JMenu editMenu;
    private javax.swing.JPanel calendarPanel;
    private javax.swing.JButton joinGroupButton;
    private javax.swing.JMenu fileMenu;
    private javax.swing.JButton newAddressButton1;
    private javax.swing.JTabbedPane pdaTabbedPane1;
    private javax.swing.JList knownGroupList;
    private javax.swing.JMenuItem deleteMenuItem2;
    private javax.swing.JTextField newGroupNameTextField;
    private javax.swing.JSplitPane jSplitPane2;
    private javax.swing.JSplitPane jSplitPane1;
    // End of variables declaration//GEN-END:variables
    
}
