/*
 * AddressBookService.java
 *
 * Created on November 29, 2001, 1:27 PM
 */

package com.sams.jxta.pda;
import com.sams.jxta.xcal.*;
import net.jxta.resolver.QueryHandler;
import java.util.Date;
import java.text.SimpleDateFormat;
import net.jxta.impl.resolver.*;
import net.jxta.protocol.*;
import net.jxta.impl.protocol.*;

import org.jdom.*;
import org.jdom.output.*;
import org.jdom.input.*;

import java.io.*;
import java.net.*;
import java.lang.reflect.*;
import java.util.*;
import net.jxta.document.AdvertisementFactory;
import  net.jxta.peergroup.*;
import  net.jxta.pipe.*;
import net.jxta.discovery.*;
//import net.jxta.document.*;
import net.jxta.document.MimeMediaType;
import net.jxta.endpoint.*;
import net.jxta.id.*;
import net.jxta.exception.*;
import net.jxta.peer.*;
import net.jxta.pipe.*;
import net.jxta.peergroup.*;
import net.jxta.platform.*;
import net.jxta.protocol.*;
import net.jxta.service.*;
import javax.swing.DefaultListModel;

/**
 *
 * @author  Administrator
 */
public class CalendarService {
    
    String syncHandlerName = "SyncCalendarList";//Pull
    String pushHandlerName = "PushCalendarList";//Push
    String credential ="SAMS";
    //Hashtable addressGroups = new Hashtable();
    Hashtable allAddresses = new Hashtable();
    net.jxta.peer.PeerID peerID;
    /** Creates new CalendarService */
    PeerGroup rootPeerGroup;
    //InfoResolver resolverX;
    private DiscoveryService discovery;
    net.jxta.impl.resolver.ResolverServiceImpl resolver;
    //SynchronizerResolver synchronizerResolver;
    /** Creates new AddressBookService */
    public CalendarService(PeerGroup rootPeerGroup) {
        this.rootPeerGroup = rootPeerGroup;
        syncHandlerName += "-"+rootPeerGroup.getPeerGroupName();
        pushHandlerName += "-"+rootPeerGroup.getPeerGroupName();

        peerID = rootPeerGroup.getPeerID();
        discovery = rootPeerGroup.getDiscoveryService();
        //addGroupInterest(rootPeerGroup);
        
        PushHandler pushHandler = new  PushHandler(pushHandlerName,credential);
        SyncHandler syncHandler = new  SyncHandler(syncHandlerName,allAddresses,credential);
        
        resolver = (ResolverServiceImpl)rootPeerGroup.getResolverService();
        
        resolver.registerHandler(pushHandlerName, pushHandler);
        resolver.registerHandler(syncHandlerName, syncHandler);
        
    }
    
    static Vector models = new Vector(1);
    
    public void addModel(DefaultListModel model){
        models.add(model);
    }
    public void addEntry( XCal xCal){
        merge(xCal);
        // Get the handler for this group
        //???        System.out.println("handlers:"+handlers+ " peerGroup:"+peerGroup);
        //???         CalendarGroupHandler handler = (GroupHandler)handlers.get(peerGroup.getPeerGroupName());
        // Publish with the resolver
        //resolver.
        update(xCal.toXML());
        
    }
    public void  update(String message){
        System.out.println("Resolver sending messages");
        ResolverQueryMsg resolverQueryMsg = null;
        resolverQueryMsg = new ResolverQuery(pushHandlerName, credential,rootPeerGroup.getPeerID().toString(), message,1);
        
        // Note that the following may throw a RuntimeException
        // if the peer is not found.
        ResolverSend resolverSend = new  ResolverSend (resolver, null, resolverQueryMsg);
        
        resolverSend.start();
        /*
        // Send query to a specific rendezvous
        //Enumeration enum = peers.elements();
        try{
            Enumeration enum = discovery.getLocalAdvertisements( DiscoveryService.PEER, null, null);
            for (;enum.hasMoreElements();){
                PeerAdvertisement peer = (PeerAdvertisement)enum.nextElement();
                if (!peer.getID().equals(peerID)){
                    System.out.println("Sending a message to peer:"+ peer.getName()+"--"+peer.getID().toString());
                    try{
                        resolver.sendQuery(peer.getID().toString(), resolverQueryMsg);
                    }catch(Exception e){
                        e.printStackTrace();
                    }
                }
            }
        }catch(java.io.IOException ioe){
            ioe.printStackTrace();
        }
         */
    }
    
    public void synchronize(){
        //synchronizerResolver.synchronize();
        System.out.println("Resolver sending synchronize");
        ResolverQueryMsg resolverQueryMsg = null;
        resolverQueryMsg = new ResolverQuery(syncHandlerName, credential,rootPeerGroup.getPeerID().toString(), "",1);
        
        // Note that the following may throw a RuntimeException
        // if the peer is not found.
        ResolverSend resolverSend = new  ResolverSend (resolver, null, resolverQueryMsg);        
        resolverSend.start();
        /*
        // Send query to a specific rendezvous
        try{
            Enumeration enum = discovery.getLocalAdvertisements( DiscoveryService.PEER, null, null);
            for (;enum.hasMoreElements();){
                PeerAdvertisement peer = (PeerAdvertisement)enum.nextElement();
                if (!peer.getID().equals(peerID)){
                    System.out.println("Sending a message to peer:"+ peer.getName()+"--"+peer.getID().toString());
                    try{
                        resolver.sendQuery(peer.getID().toString(), resolverQueryMsg);
                    }catch(Exception e){
                        e.printStackTrace();
                    }
                }
            }
        }catch(java.io.IOException ioe){
            ioe.printStackTrace();
        }
         **/
        
    }
    public void updateEntry(XCal xCal){
    }
    public void deleteEntry(XCal xCal){
    }
    /**
     * Merge the new event into our database.
     */
    public synchronized void merge(XCal xCal){
        if (allAddresses.get(xCal.getDtstamp())!=null){
            System.out.println("Address book already has this message");
            // We already have this message
            return;
        }else{
            System.out.println("New address  message");
            allAddresses.put(xCal.getDtstamp(),xCal);
        }
        // Create something we can use.
        /*
        Document newDoc =xCal.toJDOM();
        Element root = newDoc.getRootElement();
         
        Hashtable addresses = calGroups.get(peerGroup.getPeerGroupName());
        addresses.put() .addContent(root);
         */
        // Update displays
        System.out.println("*****************updating list in display");
        for (int i =0;i <models.size();i++){
            System.out.println("************updating list item:"+xCal);
            ((DefaultListModel)models.elementAt(i)).addElement(xCal);
        }
        
    }
    /**
     * implementation of QueryHandler for for synchronization.
     */
    class SyncHandler implements QueryHandler{
        protected String handlerName;
        protected String credential;
        protected Hashtable addressBook;
        protected SimpleDateFormat format   = new SimpleDateFormat("MM, dd, yyyy hh:mm:ss.S");
        
        public SyncHandler(String handlerName,Hashtable addressBook, String credential){
            this.handlerName = handlerName;
            this.credential = credential;
            this.addressBook = addressBook;
            
        }// end of constructor PullHandler()
        /**
         * call back method, when messages are received by the ResolverService
         * it calls back this method to deal with received responses
         * @param response ResolverQueryMsg reponse
         *
         * @version $Revision: 1.1 $
         * @since JXTA 1.0
         */
        public void processResponse(ResolverResponseMsg response) {
            System.out.println("Received a response");
            String textDoc = response.getResponse();
            if (textDoc ==null)return;
            //System.out.println("Received a response:"+textDoc);
            
            try{
                ByteArrayInputStream in = new ByteArrayInputStream(textDoc.getBytes());
                org.jdom.input.SAXBuilder builder = new org.jdom.input.SAXBuilder();
                org.jdom.Document doc = builder.build(in);
                org.jdom.Element root = doc.getRootElement();
                //secific to todo/calendar
                //root = root .getChild("event-list");
                List book = (List) root .getChildren("icalendar");
                ListIterator lister = book.listIterator();
                
                while (lister.hasNext()){
                    org.jdom.Element address = (org.jdom.Element) lister.next();
                    
                    //address = address .getChild("vcalendar");
                    //address = address .getChild("xcal");
                    
                    System.out.println("Received a response:"+address.getText());
                    XMLOutputter putter = new XMLOutputter("  ",true);
                    StringWriter writer = new StringWriter();
                    putter.output(address,writer);
                    
                    System.out.println(" sync messag:"+writer.toString());
                    String xml = writer.toString();
                    merge(new XCal(xml));
                }
                
            }catch(Exception je){//org.jdom.JDOMException je){
                je.printStackTrace();
                // return null;
            }
            
            
            
            //String textDoc = response.getResponse();
            //System.out.println(textDoc);
            System.out.println(((ResolverResponse)response).toString());
        }// End of processResponse()
        
        /**
         * Process the resolver query, and generate response
         * @return GenericResolverMsg Response to the query
         * @param query ResolverQueryMsg query
         */
        public ResolverResponseMsg processQuery(ResolverQueryMsg query) throws NoResponseException, ResendQueryException, DiscardQueryException{
            try{
                System.out.println("Received a synchronizer query");
                
                org.jdom.Element root = new org.jdom.Element("event-list");//,format.format( new Date(now)));
                org.jdom.Document doc = new org.jdom.Document(root);
                
                Enumeration enum = addressBook.elements();
                for(;enum.hasMoreElements();){
                    org.jdom.Document d2 =((XCal)enum.nextElement()).toJDOM();
                    org.jdom.Element ele = d2.getRootElement();
                    ele.detach();
                    root.addContent(ele);
                }
                // Return a generic response;
                ResolverResponseMsg message = null;
                XMLOutputter putter = new XMLOutputter("  ",true);
                StringWriter writer = new StringWriter();
                putter.output(doc,writer);
                
                System.out.println(" sync messag:"+writer.toString());
                message = new ResolverResponse(handlerName, credential,query.getQueryId(), writer.toString());
                return (ResolverResponseMsg)message;
            }catch(Exception e ){
                e.printStackTrace();
                throw new NoResponseException("Error processing query");
            }
        }// end of processQuery()
        
    }// end of class PullHandler
    
    class PushHandler implements QueryHandler{
        protected String handlerName;
        protected String credential;
        protected SimpleDateFormat format   = new SimpleDateFormat("MM, dd, yyyy hh:mm:ss.S");
        
        public PushHandler(String handlerName, String credential){
            this.handlerName = handlerName;
            this.credential = credential;
        }// end of constructor CalendarHandler()
        /**
         * call back method, when messages are received by the ResolverService
         * it calls back this method to deal with received responses
         * @param response ResolverQueryMsg reponse
         *
         * @version $Revision: 1.1 $
         * @since JXTA 1.0
         */
        public void processResponse(ResolverResponseMsg response) {
            System.out.println("Received a ToDo response");
            //String textDoc = response.getResponse();
            //System.out.println(textDoc);
            System.out.println(((ResolverResponse)response).toString());
        }// End of processResponse()
        
        /**
         * Process the resolver query, and generate response
         * @return GenericResolverMsg Response to the query
         * @param query ResolverQueryMsg query
         *
         * @exception NoResponseException is thrown when the resolver service
         * does not have an response and is not interested by the response.
         * @exception ResendQueryException is thrown when the resolver service
         * does not have a response, but is interested by the response. In that
         * case, the resolver service is responsible for forward the response
         * to the original peer that has issued the query.
         * @exception DiscardQueryException is thrown when the resolver service
         * has decided that the query should simply be ignored.
         * @exception IOException is thrown when the service resolver was not able to
         * process the query
         *
         * @version $Revision: 1.1 $
         * @since JXTA 1.0
         */
        public ResolverResponseMsg processQuery(ResolverQueryMsg query) throws NoResponseException, ResendQueryException, DiscardQueryException{
            System.out.println("Received a query");
            System.out.println(((ResolverQuery)query).toString());
            //net.jxta.document.StructuredTextDocument doc = null;
            String xml = query.getQuery();
            // Process the incomming data
            merge(new XCal(xml));
            
            throw new NoResponseException("Got the data we were interested in.");
                /*
            try{
                doc = (StructuredTextDocument)StructuredDocumentFactory.newStructuredDocument(new MimeMediaType( "text/xml" ),
                new ByteArrayInputStream(xml.getBytes()) );
            }catch(java.io.IOException ioe){
                ioe.printStackTrace();
            }
            // Let the originator know we received the message.
            net.jxta.document.Element e = null;
            long now = System.currentTimeMillis();
            e = doc.createElement("message consumed:",format.format( new Date(now)));
            doc.appendChild(e);
            // Return a generic response;
            ResolverResponseMsg message = null;
            xml = serializeDoc(doc);
            message = new ResolverResponse(handlerName, credential,query.getQueryId(), xml);
            return (ResolverResponseMsg)message;
                 */
        }// end of processQuery()
        
    }// end of class CalendarHandler
    
}
